com.pixelmed.dicom

## Class UnsignedShortAttribute

- java.lang.Object
- - com.pixelmed.dicom.Attribute
  - - com.pixelmed.dicom.UnsignedShortAttribute

-     public class UnsignedShortAttribute
      extends Attribute

  A concrete class specializing `Attribute` for Unsigned Short (US) attributes.

  Though an instance of this class may be created using its constructors, there is also a factory class, `AttributeFactory`.

  See Also:
    `Attribute`, `AttributeFactory`, `AttributeList`

- - ### Field Summary

    - ### Fields inherited from class com.pixelmed.dicom.Attribute

      `valueLength, valueMultiplicity`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `UnsignedShortAttribute(AttributeTag t)` Construct an (empty) attribute.
    `UnsignedShortAttribute(AttributeTag t, long vl, DicomInputStream i)` Read an attribute from an input stream.
    `UnsignedShortAttribute(AttributeTag t, java.lang.Long vl, DicomInputStream i)` Read an attribute from an input stream.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addValue(double v)` Add a(nother) double value after any existing values of this attribute.
    `void` | `addValue(float v)` Add a(nother) float value after any existing values of this attribute.
    `void` | `addValue(int v)` Add a(nother) int value after any existing values of this attribute.
    `void` | `addValue(long v)` Add a(nother) long value after any existing values of this attribute.
    `void` | `addValue(short v)` Add a(nother) short value after any existing values of this attribute.
    `void` | `addValue(java.lang.String v)` Add a(nother) `String` value after any existing values of this attribute.
    `double[]` | `getDoubleValues()` Get the values of this attribute as a double array.
    `float[]` | `getFloatValues()` Get the values of this attribute as a float array.
    `int[]` | `getIntegerValues()` Get the values of this attribute as an int array.
    `long[]` | `getLongValues()` Get the values of this attribute as a long array.
    `short[]` | `getShortValues()` Get the values of this attribute as a short array.
    `java.lang.String[]` | `getStringValues(java.text.NumberFormat format)` Get the values of this attribute as strings.
    `byte[]` | `getVR()` Get the value representation of this attribute (US).
    `void` | `removeValues()` Remove any existing values, making the attribute empty (zero length).
    `void` | `setValues(short[] v)` Replace any existing values with the supplied array of short.
    `java.lang.String` | `toString(DicomDictionary dictionary)` Dump the contents of the attribute as a human-readable string.
    `void` | `write(DicomOutputStream o)` Write the entire attribute (including values) to the output stream.

    - ### Methods inherited from class com.pixelmed.dicom.Attribute

      `addValue, getByteValues, getDelimitedStringValuesOrDefault, getDelimitedStringValuesOrDefault, getDelimitedStringValuesOrDefault, getDelimitedStringValuesOrDefault, getDelimitedStringValuesOrDefault, getDelimitedStringValuesOrDefault, getDelimitedStringValuesOrEmptyString, getDelimitedStringValuesOrEmptyString, getDelimitedStringValuesOrEmptyString, getDelimitedStringValuesOrEmptyString, getDelimitedStringValuesOrEmptyString, getDelimitedStringValuesOrEmptyString, getDelimitedStringValuesOrNull, getDelimitedStringValuesOrNull, getDelimitedStringValuesOrNull, getDelimitedStringValuesOrNull, getDelimitedStringValuesOrNull, getDelimitedStringValuesOrNull, getDoubleValues, getDoubleValues, getElement, getFloatValues, getFloatValues, getGroup, getIntegerValues, getIntegerValues, getLongValues, getLongValues, getOriginalStringValues, getPaddedVL, getSingleDoubleValueOrDefault, getSingleDoubleValueOrDefault, getSingleDoubleValueOrDefault, getSingleFloatValueOrDefault, getSingleFloatValueOrDefault, getSingleFloatValueOrDefault, getSingleIntegerValueOrDefault, getSingleIntegerValueOrDefault, getSingleIntegerValueOrDefault, getSingleLongValueOrDefault, getSingleLongValueOrDefault, getSingleLongValueOrDefault, getSingleStringValueOrDefault, getSingleStringValueOrDefault, getSingleStringValueOrDefault, getSingleStringValueOrDefault, getSingleStringValueOrDefault, getSingleStringValueOrDefault, getSingleStringValueOrEmptyString, getSingleStringValueOrEmptyString, getSingleStringValueOrEmptyString, getSingleStringValueOrEmptyString, getSingleStringValueOrEmptyString, getSingleStringValueOrEmptyString, getSingleStringValueOrNull, getSingleStringValueOrNull, getSingleStringValueOrNull, getSingleStringValueOrNull, getSingleStringValueOrNull, getSingleStringValueOrNull, getStringValues, getStringValues, getStringValues, getStringValues, getStringValues, getTag, getVL, getVM, getVRAsString, isValid, repairValues, setValue, setValue, setValue, setValue, setValue, setValue, setValue, setValues, setValues, setValues, toString, writeBase`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### UnsignedShortAttribute

          public UnsignedShortAttribute(AttributeTag t)

      Construct an (empty) attribute.

      Parameters:
        `t` - the tag of the attribute

    - #### UnsignedShortAttribute

          public UnsignedShortAttribute(AttributeTag t,
                                        long vl,
                                        DicomInputStream i)
                                 throws java.io.IOException,
                                        DicomException

      Read an attribute from an input stream.

      Parameters:
        `t` - the tag of the attribute
        `vl` - the value length of the attribute
        `i` - the input stream
      Throws:
        `java.io.IOException`
        `DicomException`

    - #### UnsignedShortAttribute

          public UnsignedShortAttribute(AttributeTag t,
                                        java.lang.Long vl,
                                        DicomInputStream i)
                                 throws java.io.IOException,
                                        DicomException

      Read an attribute from an input stream.

      Parameters:
        `t` - the tag of the attribute
        `vl` - the value length of the attribute
        `i` - the input stream
      Throws:
        `java.io.IOException`
        `DicomException`

  - ### Method Detail

    - #### write

          public void write(DicomOutputStream o)
                     throws DicomException,
                            java.io.IOException

      Description copied from class: `Attribute`

      Write the entire attribute (including values) to the output stream.

      Specified by:
        `write` in class `Attribute`
      Parameters:
        `o` -
      Throws:
        `java.io.IOException`
        `DicomException`

    - #### toString

          public java.lang.String toString(DicomDictionary dictionary)

      Description copied from class: `Attribute`

      Dump the contents of the attribute as a human-readable string.

      No new line is appended.

      The result is of the form:

           (0xgggg,0xeeee) Name VR=<XX> VL=<0xnnnn> <...>

      For example:

           (0x0018,0x0020) ScanningSequence VR=<CS> VL=<0x2> <GR>

      Overrides:
        `toString` in class `Attribute`
      Parameters:
        `dictionary` - the dictionary to use to look up the name
      Returns:
        a single `String` value

    - #### getStringValues

          public java.lang.String[] getStringValues(java.text.NumberFormat format)
                                             throws DicomException

      Description copied from class: `Attribute`

      Get the values of this attribute as strings.

      The strings may have been cleaned up into a canonical form, such as to remove padding as well as numbers formatted.

      Overrides:
        `getStringValues` in class `Attribute`
      Parameters:
        `format` - the format to use for each numerical or decimal value
      Returns:
        the values as an array of `String`
      Throws:
        `DicomException`

    - #### getShortValues

          public short[] getShortValues()
                                 throws DicomException

      Description copied from class: `Attribute`

      Get the values of this attribute as a short array.

      Overrides:
        `getShortValues` in class `Attribute`
      Returns:
        the values as an array of short
      Throws:
        `DicomException`

    - #### getIntegerValues

          public int[] getIntegerValues()
                                 throws DicomException

      Description copied from class: `Attribute`

      Get the values of this attribute as an int array.

      Overrides:
        `getIntegerValues` in class `Attribute`
      Returns:
        the values as an array of int
      Throws:
        `DicomException`

    - #### getLongValues

          public long[] getLongValues()
                               throws DicomException

      Description copied from class: `Attribute`

      Get the values of this attribute as a long array.

      Overrides:
        `getLongValues` in class `Attribute`
      Returns:
        the values as an array of long
      Throws:
        `DicomException`

    - #### getFloatValues

          public float[] getFloatValues()
                                 throws DicomException

      Description copied from class: `Attribute`

      Get the values of this attribute as a float array.

      Overrides:
        `getFloatValues` in class `Attribute`
      Returns:
        the values as an array of float
      Throws:
        `DicomException`

    - #### getDoubleValues

          public double[] getDoubleValues()
                                   throws DicomException

      Description copied from class: `Attribute`

      Get the values of this attribute as a double array.

      Overrides:
        `getDoubleValues` in class `Attribute`
      Returns:
        the values as an array of double
      Throws:
        `DicomException`

    - #### addValue

          public void addValue(short v)
                        throws DicomException

      Description copied from class: `Attribute`
      Add a(nother) short value after any existing values of this attribute.
      Overrides:
        `addValue` in class `Attribute`
      Parameters:
        `v` -
      Throws:
        `DicomException`

    - #### addValue

          public void addValue(int v)
                        throws DicomException

      Description copied from class: `Attribute`
      Add a(nother) int value after any existing values of this attribute.
      Overrides:
        `addValue` in class `Attribute`
      Parameters:
        `v` -
      Throws:
        `DicomException`

    - #### addValue

          public void addValue(long v)
                        throws DicomException

      Description copied from class: `Attribute`
      Add a(nother) long value after any existing values of this attribute.
      Overrides:
        `addValue` in class `Attribute`
      Parameters:
        `v` -
      Throws:
        `DicomException`

    - #### addValue

          public void addValue(float v)
                        throws DicomException

      Description copied from class: `Attribute`
      Add a(nother) float value after any existing values of this attribute.
      Overrides:
        `addValue` in class `Attribute`
      Parameters:
        `v` -
      Throws:
        `DicomException`

    - #### addValue

          public void addValue(double v)
                        throws DicomException

      Description copied from class: `Attribute`
      Add a(nother) double value after any existing values of this attribute.
      Overrides:
        `addValue` in class `Attribute`
      Parameters:
        `v` -
      Throws:
        `DicomException`

    - #### addValue

          public void addValue(java.lang.String v)
                        throws DicomException

      Description copied from class: `Attribute`
      Add a(nother) `String` value after any existing values of this attribute.
      Overrides:
        `addValue` in class `Attribute`
      Parameters:
        `v` -
      Throws:
        `DicomException`

    - #### setValues

          public void setValues(short[] v)
                         throws DicomException

      Description copied from class: `Attribute`
      Replace any existing values with the supplied array of short.
      Overrides:
        `setValues` in class `Attribute`
      Parameters:
        `v` -
      Throws:
        `DicomException`

    - #### removeValues

          public void removeValues()

      Description copied from class: `Attribute`

      Remove any existing values, making the attribute empty (zero length).

      Specified by:
        `removeValues` in class `Attribute`

    - #### getVR

          public byte[] getVR()

      Get the value representation of this attribute (US).

      Overrides:
        `getVR` in class `Attribute`
      Returns:
        'U','S' in ASCII as a two byte array; see `ValueRepresentation`